<html>
<head>
<title>Ogre::GLES2PixelUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GLES2PixelUtil.html">GLES2PixelUtil</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GLES2PixelUtil Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GLES2PixelUtil" -->
<p>Class to do pixel format mapping between GL and OGRE.  
 <a href="classOgre_1_1GLES2PixelUtil.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGLES2PixelFormat_8h_source.html">OgreGLES2PixelFormat.h</a>&gt;</code></p>

<p><a href="classOgre_1_1GLES2PixelUtil-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#a29ce8044eeb3e96b2b04392484901802">getGLOriginFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the appropriate GL one.  <a href="#a29ce8044eeb3e96b2b04392484901802"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#a364f6418df681dade1745f4a3539597d">getGLOriginDataType</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns type that must be provided to GL as data type for reading it into the GPU.  <a href="#a364f6418df681dade1745f4a3539597d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#a204cf5cc42d6caadf4998bdf7638bcb8">getGLInternalFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat, bool hwGamma=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the type that must be provided to GL as internal format.  <a href="#a204cf5cc42d6caadf4998bdf7638bcb8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#aeee4ec969fb9fc5988bd439e94d745a5">getClosestGLInternalFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat, bool hwGamma=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the type that must be provided to GL as internal format.  <a href="#aeee4ec969fb9fc5988bd439e94d745a5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#a65af2901533813bc0b1b12f3ae6be120">getClosestOGREFormat</a> (GLenum fmt, GLenum dataType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to get the closest matching OGRE format to an internal GL format.  <a href="#a65af2901533813bc0b1b12f3ae6be120"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#afabdf4ba53a2bc7d214f5233fc28cc89">getMaxMipmaps</a> (size_t width, size_t height, size_t depth, <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum number of Mipmaps that can be generated until we reach the mininum format possible.  <a href="#afabdf4ba53a2bc7d214f5233fc28cc89"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#aa8eb82b332814fac5dde2cd24ed17965">optionalPO2</a> (size_t value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns next power-of-two size if required by render system, in case RSC_NON_POWER_OF_2_TEXTURES is supported it returns value as-is.  <a href="#aa8eb82b332814fac5dde2cd24ed17965"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLES2PixelUtil.html#a67adb821d6a2d341a483aa344ced0a36">convertToGLformat</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;src, const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;dst)</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class to do pixel format mapping between GL and OGRE. </p>

<p>Definition at line <a class="el" href="OgreGLES2PixelFormat_8h_source.html#l00039">39</a> of file <a class="el" href="OgreGLES2PixelFormat_8h_source.html">OgreGLES2PixelFormat.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a67adb821d6a2d341a483aa344ced0a36"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::convertToGLformat" ref="a67adb821d6a2d341a483aa344ced0a36" args="(const PixelBox &amp;src, const PixelBox &amp;dst)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1GLES2PixelUtil.html#a67adb821d6a2d341a483aa344ced0a36">Ogre::GLES2PixelUtil::convertToGLformat</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="aeee4ec969fb9fc5988bd439e94d745a5"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getClosestGLInternalFormat" ref="aeee4ec969fb9fc5988bd439e94d745a5" args="(PixelFormat mFormat, bool hwGamma=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLES2PixelUtil.html#aeee4ec969fb9fc5988bd439e94d745a5">Ogre::GLES2PixelUtil::getClosestGLInternalFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>hwGamma</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the type that must be provided to GL as internal format. </p>
<p>If no match exists, returns the closest match. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mFormat</td><td>The pixel format </td></tr>
    <tr><td class="paramname">hwGamma</td><td>Whether a hardware gamma-corrected version is requested </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a65af2901533813bc0b1b12f3ae6be120"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getClosestOGREFormat" ref="a65af2901533813bc0b1b12f3ae6be120" args="(GLenum fmt, GLenum dataType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> <a class="el" href="classOgre_1_1GLES2PixelUtil.html#a65af2901533813bc0b1b12f3ae6be120">Ogre::GLES2PixelUtil::getClosestOGREFormat</a> </td>
          <td>(</td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>dataType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function to get the closest matching OGRE format to an internal GL format. </p>
<p>To be precise, the format will be chosen that is most efficient to transfer to the card without losing precision. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>It is valid for this function to always return PF_A8R8G8B8. </dd></dl>

</div>
</div>
<a class="anchor" id="a204cf5cc42d6caadf4998bdf7638bcb8"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getGLInternalFormat" ref="a204cf5cc42d6caadf4998bdf7638bcb8" args="(PixelFormat mFormat, bool hwGamma=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLES2PixelUtil.html#a204cf5cc42d6caadf4998bdf7638bcb8">Ogre::GLES2PixelUtil::getGLInternalFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>hwGamma</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the type that must be provided to GL as internal format. </p>
<p>GL_NONE if no match exists. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mFormat</td><td>The pixel format </td></tr>
    <tr><td class="paramname">hwGamma</td><td>Whether a hardware gamma-corrected version is requested </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a364f6418df681dade1745f4a3539597d"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getGLOriginDataType" ref="a364f6418df681dade1745f4a3539597d" args="(PixelFormat mFormat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLES2PixelUtil.html#a364f6418df681dade1745f4a3539597d">Ogre::GLES2PixelUtil::getGLOriginDataType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns type that must be provided to GL as data type for reading it into the GPU. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>a GLenum describing the data type, or 0 if there is no exactly matching one (and conversion is needed) </dd></dl>

</div>
</div>
<a class="anchor" id="a29ce8044eeb3e96b2b04392484901802"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getGLOriginFormat" ref="a29ce8044eeb3e96b2b04392484901802" args="(PixelFormat mFormat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLES2PixelUtil.html#a29ce8044eeb3e96b2b04392484901802">Ogre::GLES2PixelUtil::getGLOriginFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the appropriate GL one. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>a GLenum describing the format, or 0 if there is no exactly matching one (and conversion is needed) </dd></dl>

</div>
</div>
<a class="anchor" id="afabdf4ba53a2bc7d214f5233fc28cc89"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::getMaxMipmaps" ref="afabdf4ba53a2bc7d214f5233fc28cc89" args="(size_t width, size_t height, size_t depth, PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t <a class="el" href="classOgre_1_1GLES2PixelUtil.html#afabdf4ba53a2bc7d214f5233fc28cc89">Ogre::GLES2PixelUtil::getMaxMipmaps</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>depth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>format</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the maximum number of Mipmaps that can be generated until we reach the mininum format possible. </p>
<p>This does not count the base level. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>The width of the area </td></tr>
    <tr><td class="paramname">height</td><td>The height of the area </td></tr>
    <tr><td class="paramname">depth</td><td>The depth of the area </td></tr>
    <tr><td class="paramname">format</td><td>The format of the area </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>In case that the format is non-compressed, this simply returns how many times we can divide this texture in 2 until we reach 1x1. For compressed formats, constraints apply on minimum size and alignment so this might differ. </dd></dl>

</div>
</div>
<a class="anchor" id="aa8eb82b332814fac5dde2cd24ed17965"></a><!-- doxytag: member="Ogre::GLES2PixelUtil::optionalPO2" ref="aa8eb82b332814fac5dde2cd24ed17965" args="(size_t value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t <a class="el" href="classOgre_1_1GLES2PixelUtil.html#aa8eb82b332814fac5dde2cd24ed17965">Ogre::GLES2PixelUtil::optionalPO2</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns next power-of-two size if required by render system, in case RSC_NON_POWER_OF_2_TEXTURES is supported it returns value as-is. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGLES2PixelFormat_8h_source.html">OgreGLES2PixelFormat.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:29
</p>
</body>
</html>
